﻿/**
 * @author SamsamTS
 */
import com.samsamts.Events.Event;
import com.samsamts.Events.EventHandler;
import com.samsamts.Events.WrapEventArgs;
import com.samsamts.Utils.Delegate;

class com.samsamts.Events.EventWrapper extends Event
{
	//{ Author properties
	public static var className:String = "EventWrapper";
	public static var classPackage:String = "com.samsamts.Events";
	public static var version:String = "1.0.0";
	public static var author:String = "SamsamTS";
	public static var link:String = "http://www.samsamts.com/blog/";
	//}
	
	public function EventWrapper(o:Object, evtName:String)
	{
		super();
		m_evtName = evtName;
		m_target = o;
	}
	
	//{ Overrides
	public function Add(handler:EventHandler):Event
	{
		super.Add(handler)
		
		if(m_target[m_evtName] == undefined)
			m_target[m_evtName] = Delegate.Create(this, Trigger);
		
		return this;
	}
	public function Remove(handler:EventHandler):Event
	{
		super.Remove(handler);
		
		if(m_arrHandlers.length == 0)
			delete m_target[m_evtName];
		
		return this;
	}
	public function toString():String
	{
		return "[EventWrapper]";
	}
	//}
	
	//{ private
	private var m_target:Object;
	private var m_evtName:String;
	
	private function Trigger():Void
	{
		super.Trigger(m_target, new WrapEventArgs(arguments));
	}
	//}
}